var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { useFormatter } from "./formatter";
/**
 * Validates that a value is at most {chars} long
 * T is type of formatter result
 * U is type of validation result
 * @param chars Maximum number of characters
 * @param msg Error messages when invalid
 */
export var atMost = function (params, msg) { return function (_a, formatter) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value) {
        if (!value) {
            return valid();
        }
        var format = useFormatter(msg, __assign({}, params, { value: value }), formatter);
        return value.toString().length <= params.chars
            ? valid()
            : invalid(format("long", "Entry must be no more than " + params.chars + " characters long"));
    };
}; };
//# sourceMappingURL=atMost.js.map