import { CreateValidatorOptions, CreateValidator, ValidFieldResult, InvalidFieldResult, CovalidatedFieldResult, Validator } from "./typesAndGuards";
/**
 * Passed to validation functions to be called when value is valid
 */
export declare const validFn: () => ValidFieldResult;
/**
 * Passed to validation functions to be called when value is invalid
 * @param error An error message - why is the value invalid?
 */
export declare const invalidFn: (error: string) => InvalidFieldResult;
/**
 * Passes the validation reporters to each entry in an object
 * @param validationMap Object of field validators { [ fieldName: string ]: ValidationFunction }
 */
export declare const create: <T, U>(validationMap: Record<string, CreateValidator<T, string | number, U, any>>, options?: CreateValidatorOptions<U, any> | undefined) => Record<string, Validator<string | number, InvalidFieldResult | ValidFieldResult | CovalidatedFieldResult | Promise<InvalidFieldResult | ValidFieldResult | CovalidatedFieldResult>>>;
