var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
/**
 * Passed to validation functions to be called when value is valid
 */
export var validFn = function () { return ({
    valid: true
}); };
/**
 * Passed to validation functions to be called when value is invalid
 * @param error An error message - why is the value invalid?
 */
export var invalidFn = function (error) { return ({
    valid: false,
    error: error
}); };
/**
 * Passes the validation reporters to each entry in an object
 * @param validationMap Object of field validators { [ fieldName: string ]: ValidationFunction }
 */
export var create = function (validationMap, options) {
    return Object.entries(validationMap).reduce(function (out, _a) {
        var key = _a[0], value = _a[1];
        return (__assign({}, out, (_b = {}, _b[key] = value({ valid: validFn, invalid: invalidFn }, options), _b)));
        var _b;
    }, {});
};
//# sourceMappingURL=create.js.map