var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { useFormatter } from "./formatter";
/**
 * Validates that a value is the same as another field
 * @param params The field to match
 * @param msg Error messages when invalid
 */
export var equalTo = function (params, msg) { return function (_a, options) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value, fields) {
        var format = useFormatter(msg, __assign({}, params, { value: value }), options);
        if (!fields ||
            !fields[params.field] ||
            value !== fields[params.field].value) {
            return invalid(format("different", "Must match " + params.field));
        }
        return valid();
    };
}; };
//# sourceMappingURL=equalTo.js.map