import { Message, FieldResult, CreateValidator } from "./typesAndGuards";
export interface MatchesParams {
    regex: RegExp;
}
export interface MatchesMessages<T = string, U = string> {
    different?: Message<T, void, U>;
}
/**
 * Validates that a value matches a RegExp
 * @param params The RegExp against which to test the value
 * @param msg Error messages when invalid
 */
export declare const matches: <T, U>(params: MatchesParams, msg?: MatchesMessages<T, string> | undefined) => CreateValidator<FieldResult, U, T, MatchesParams>;
