var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { useFormatter } from "./formatter";
/**
 * Validates that a value matches a RegExp
 * @param params The RegExp against which to test the value
 * @param msg Error messages when invalid
 */
export var matches = function (params, msg) { return function (_a, options) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value) {
        if (!value) {
            return valid();
        }
        var format = useFormatter(msg, __assign({}, params, { value: value }), options);
        return params.regex.test((value || "").toString())
            ? valid()
            : invalid(format("different", "Must match pattern"));
    };
}; };
//# sourceMappingURL=matches.js.map