import { NotUndefinedMessage } from "./required";
import { Message, CreateValidator, FieldResult } from "./typesAndGuards";
export interface NumericMessages<T = string, U = string> extends NotUndefinedMessage<T, U> {
    nonNumeric?: Message<T, void, U>;
}
/**
 * Validates that a value is only numbers
 * @param msg Error messages when invalid
 */
export declare const numeric: <T, U>(msg?: NumericMessages<T, string> | undefined) => CreateValidator<FieldResult, U, T, {
    value: U;
}>;
