import { useFormatter } from "./formatter";
/**
 * Validates that a value is not undefined or zero-length
 * @param msg Error messages when invalid
 */
export var required = function (msg) { return function (_a, options) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value) {
        var format = useFormatter(msg, { value: value }, options);
        return typeof value !== "undefined" && value.toString().length > 0
            ? valid()
            : invalid(format("undef", "Required"));
    };
}; };
//# sourceMappingURL=required.js.map